(*        GREATIS DELPHI PAGES         *)
(* Copyright (C) 2001 Greatis Software *)
(*  web: http://www.greatisdelphi.com  *)
(*     e-mail: delphi@greatis.com      *)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    New1: TMenuItem;
    procedure New1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ClientWndProc(var Message: TMessage);
    procedure DrawImage;
    { Public declarations }
  protected
    procedure CreateWnd; override;
  end;

var
  Form1: TForm1;
  NewClient, OldClient: TFarProc;
  MyDC: hDC;

implementation

uses unit2;

{$R *.DFM}

procedure TForm1.CreateWnd;
begin
  inherited CreateWnd;
  NewClient:=MakeObjectInstance(ClientWndProc);
  OldClient:=Pointer(GetWindowLong(ClientHandle, GWL_WNDPROC));
  SetWindowLong(ClientHandle, GWL_WNDPROC, LongInt(NewClient));
end;

procedure TForm1.DrawImage;
{ This procedure tiles the image on the form's client area }
var
  i, j: Integer;
  WndRect, ImageRect: TRect;
  Rows, Cols: Integer;
begin
  GetWindowRect(ClientHandle, WndRect);
  ImageRect:=Image1.ClientRect;
  Rows:=WndRect.Bottom div ImageRect.Bottom;
  Cols:=WndRect.Right div ImageRect.Right;
  with Image1 do
    for i:=0 to Rows+1 do
      for j:=0 to Cols+1  do
        BitBlt(MyDC, j*Picture.Width, i*Picture.Height, Picture.Width,
          Picture.Height, Picture.Bitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

procedure TForm1.ClientWndProc(var Message: TMessage);
begin
  case Message.Msg of
    WM_ERASEBKGND:
    begin
      CallWindowProc(OldClient, ClientHandle, Message.Msg, Message.wParam, Message.lParam);
      MyDC:=TWMEraseBkGnd(Message).DC;
      DrawImage;
      Message.Result:=1;
    end;
    WM_VSCROLL, WM_HSCROLL:
    begin
      Message.Result := CallWindowProc(OldClient, ClientHandle, Message.Msg, Message.wParam, Message.lParam);
      InvalidateRect(ClientHandle, nil, True);
      end;
    else
      Message.Result := CallWindowProc(OldClient, ClientHandle, Message.Msg, Message.wParam, Message.lParam);
  end;
end;

procedure TForm1.New1Click(Sender: TObject);
var
  ChildForm: TForm;
begin
  ChildForm:=TForm2.Create(Application);
  ChildForm.Caption:='ChildForm-'+IntToStr(MDIChildCount) ;
end;

end.
